SystemOrganization addCategory: #Roassal2Spec!

AbstractWidgetModel subclass: #RoassalModel
	instanceVariableNames: 'script'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2Spec'!

!RoassalModel commentStamp: '<historical>' prior: 0!
I am a Spec model to embed Roassal2 visualizations!

!RoassalModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/6/2014 13:00'!
defaultSpec
	<spec>
	
	^ #(MorphicRoassalAdapter
		adapt: #(model))! !

!RoassalModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 1/8/2014 21:13'!
initialize

	super initialize.

	script := [ :view :canvas | ] asValueHolder.
	script whenChangedDo: [ self refresh ]! !

!RoassalModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/8/2014 21:13'!
refresh

	self changed: #applyScript with: #()! !

!RoassalModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/6/2014 12:59'!
script

	^ script value! !

!RoassalModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/6/2014 12:59'!
script: aBlock

	script value: aBlock! !

AbstractMorphicAdapter subclass: #MorphicRoassalAdapter
	instanceVariableNames: 'view canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2Spec'!

!MorphicRoassalAdapter commentStamp: '<historical>' prior: 0!
I am bridging RoassalModel and RTView!

!MorphicRoassalAdapter class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/6/2014 13:21'!
defaultSpec
	<spec>
	
	^ #(RTView)! !

!MorphicRoassalAdapter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/8/2014 21:28'!
adapt: aComposableModel

	super adapt: aComposableModel.
	view := widget.
	canvas := widget createAndFillCanvas.
	widget := canvas buildMorph.
	widget
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	
	self applyScript
	! !

!MorphicRoassalAdapter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/8/2014 21:28'!
applyScript
	
	self freeCanvas.
	
	self model script
		cull: view
		cull: canvas.
		
	self widgetDo: [ :w | w startStepping ]! !

!MorphicRoassalAdapter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/6/2014 13:30'!
freeCanvas
	
	view elements do: [ :e | view removeElement: e ].	
	self widgetDo: [ :w | w changed ]! !
